/* $Id: hammerSine.java,v 1.7 2012/01/20 06:28:31 mit Exp $
/* hammerSine.java v0.1 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class hammerSine extends Applet
    implements AdjustmentListener, ActionListener
{
    static final int Partial = 22;
    static final int FONT = 12;
    private Scrollbar scWide;
    private Button btP;
    private Button btM;
    private Panel PS;
    private Panel PE;
    private Label lWide;

    int W, H;
    double GAIN = 250;
    DecimalFormat df1;
    private static final long serialVersionUID = 1L;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, FONT));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
        df1 = new DecimalFormat("#0.0#");

	PS = new Panel();
        PS.setLayout(new GridLayout(1,2,0,0));

        scWide = new Scrollbar(Scrollbar.HORIZONTAL,1,1,10,101);
        PS.add(scWide);
        scWide.addAdjustmentListener(this);

	lWide = new Label(" Wide: ___");
        PS.add(lWide);

        add(PS, "South");

	PE = new Panel();
	PE.setLayout(new GridLayout(4,1,0,0));

	PE.add(new Label());
	PE.add(new Label());

	btP = new Button("+");
	PE.add(btP);
        btP.addActionListener(this);

	btM = new Button("-");
	PE.add(btM);
        btM.addActionListener(this);

	add(PE, "East");
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;
    }
    public Dimension getCanvasD() {
        Dimension dp = PS.getSize();
	Dimension de = PE.getSize();
        Dimension da = getSize();
        int cw = da.width-de.width;
        int ch = da.height-dp.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        repaint();
    }
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == btP)
	    setGain(true);
	else if (e.getSource() == btM)
	    setGain(false);

	repaint();
    }
    public void setGain(boolean sw) {
	int min = 50;
	int max = 1000;
	double by = Math.sqrt(2);

	if (sw)
	    GAIN = GAIN*by;
	else
	    GAIN = GAIN/by;

	if (GAIN > max)
	    GAIN = max;
	else if (GAIN < min)
	    GAIN = min;
    }
    public double calcHammer(double x, double par) {
	return (1.0-Math.cos(par*Math.PI*x*0.1))/par;
    }
    public double calcHammerSine(double x, double par) {
	double ab = 0.1*x;
	double ba = 1.0/ab;

	double val0 = (1.0/(2.0*(ba-par)))*Math.sin((1.0-par*ab)*Math.PI);
	double val1 = (1.0/(2.0*(ba+par)))*Math.sin((1.0+par*ab)*Math.PI);

	return val0-val1;
    }
    //
    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0, 0, W, H);

	double xb = scWide.getValue()/10.0;
	int Sft = FONT*3;            // 
	int Base = H-Sft;            // 

	dispLine(g, Base);
	dispHLine(g, Base);
	set_label(xb);

	int max = 200;
	double dl = Partial/(double)max;
	double dx = W/(double)max;
	int xx, wd = (int)(dx/2);
	double yy, yb, li;
	Point ha0, ha1 = new Point(0,0); // Ⱦϥޡ
	Point hb0, hb1 = new Point(0,0); // ϥޡ
	for (int i = 0; i < max; i++) {
	    li = dl*i;
	    yy = Math.abs(calcHammerSine(xb, li)*GAIN);
	    yb = calcHammer(xb, li)*GAIN;

	    //System.out.println(i+": "+(float)ys);

	    xx = (int)(dx*i);
	    ha0 = new Point(xx, (int)(Base-yy));
	    hb0 = new Point(xx, (int)(Base-yb));
	    if (i == 0) {
		ha1 = ha0;
		hb1 = hb0;
	    }

	    g.setColor(Color.green);
	    g.drawLine(ha0.x, ha0.y, ha1.x, ha1.y);
	    ha1 = ha0;

	    g.setColor(Color.orange);
	    g.drawLine(hb0.x, hb0.y, hb1.x, hb1.y);
	    hb1 = hb0;
	}

	g.setColor(Color.green);
	g.drawString("Half Sine Wave", W/2, FONT*2);

	g.setColor(Color.orange);
	g.drawString("Square", W/2, FONT*3);
    }
    public void set_label(double xb) {
	lWide.setText(" Wide: "+dform(xb/10));
    }
    public void dispHLine(Graphics g, int base) {
	double val = 0.1;
	if (GAIN < 60)
	    val = 0.5;
	else if (GAIN < 80)
	    val = 0.4;
	else if (GAIN < 110)
	    val = 0.3;
	else if (GAIN < 210)
	    val = 0.2;

	double iv;
	int yy;
	for (int i = 0; i < 10; i++) {
	    iv = i*val;
	    yy = (int)(base-iv*GAIN);

	    g.setColor(Color.gray);
	    g.drawLine(0, yy, W, yy);

	    g.setColor(Color.lightGray);
	    g.drawString(dform(iv), W-25, yy);
	}
    }
    public void dispLine(Graphics g, int base) {
	g.setColor(Color.lightGray);
	g.drawLine(0, base, W, base);

	double dx = W/(double)Partial;
	int xx;
	for (int i = 0; i <= Partial; i++) {
	    xx = (int)(dx*i);

	    g.setColor(Color.gray);
	    g.drawLine(xx, 0, xx, base);

	    if (i % 5 == 0 & i != 0 | i == 1) {
		g.setColor(Color.lightGray);
		g.drawLine(xx, base, xx, base+FONT);

		g.setColor(Color.white);
		g.drawString(i+"", xx, base+FONT*2);
	    } else {
		g.setColor(Color.lightGray);
		g.drawLine(xx, base, xx, base+FONT/2);
	    }
	}

	g.setColor(Color.white);
	g.drawString("Partial", W/3, base+FONT*3);
    }
}